Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultHDRFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultHDRFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultHDRFile.java	(revision 43876)
@@ -0,0 +1,598 @@
+package org.gvsig.basicformats.impl;
+
+
+import java.io.File;
+import java.io.IOException;
+import java.nio.ByteOrder;
+import java.util.List;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.basicformats.HDRFile;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.primitive.Envelope;
+import org.gvsig.fmap.geom.primitive.Point;
+import org.gvsig.raster.lib.buffer.api.BufferManager;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class DefaultHDRFile implements HDRFile {
+
+    // http://resources.esri.com/help/9.3/arcgisdesktop/com/gp_toolref/spatial_analyst_tools/esri_ascii_raster_format.htm
+    private static final Logger logger = LoggerFactory.getLogger(DefaultHDRFile.class);
+
+    private File source;
+    private String comments;
+
+    private int nrows = NONE;
+    private int ncols = NONE;
+    private int nbands = 1;
+    private int nbits = 8;
+    private String pixeltype;
+    private String byteorder_word;
+    private ByteOrder byteorder = ByteOrder.nativeOrder();
+    private String layout = LAYOUT_BIL;
+    private int skipbytes = 0;
+    private double ulxmax = Double.NaN;
+    private double ulymax = Double.NaN;
+    private double xdim = Double.NaN;
+    private double ydim = Double.NaN;
+    private int bandrowbytes = NONE;
+    private int totalrowbytes = NONE;
+    private int bandgapbytes = 0;
+    private boolean valid = false;
+    private double nodata_value = Double.NaN;
+
+    // X coordinate of the origin (by center or lower left corner of the cell).
+    private double xllcorner = Double.NaN;
+
+    // Y coordinate of the origin (by center or lower left corner of the cell).
+    private double yllcorner = Double.NaN;
+
+    private int cellsize = NONE;
+
+    public DefaultHDRFile() {
+        this.source = null;
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath()) + "." + FILE_EXTENSION);
+        return f;
+    }
+
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                List<String> lines = FileUtils.readLines(f);
+                if (lines != null) {
+                    this.source = f.getAbsoluteFile();
+                    int lineno = 1;
+                    for (String line : lines) {
+                        String[] words = StringUtils.split(line.trim().toLowerCase());
+                        try {
+                            switch (words[0]) {
+                                case "nrows":
+                                    this.nrows = Integer.parseInt(words[1]);
+                                    break;
+                                case "ncols":
+                                    this.ncols = Integer.parseInt(words[1]);
+                                    break;
+                                case "nbands":
+                                    this.nbands = Integer.parseInt(words[1]);
+                                    break;
+                                case "nbits":
+                                    this.nbits = Integer.parseInt(words[1]);
+                                    break;
+                                case "pixeltype":
+                                    this.pixeltype = words[1];
+                                    break;
+                                case "byteorder":
+                                    this.byteorder_word = words[1];
+                                    break;
+                                case "layout":
+                                    this.layout = words[1];
+                                    break;
+                                case "skipbytes":
+                                    this.skipbytes = Integer.parseInt(words[1]);
+                                    break;
+                                case "nodata_value":
+                                    this.nodata_value = Double.parseDouble(words[1]);
+                                    break;
+                                case "cellsize":
+                                    this.cellsize = Integer.parseInt(words[1]);
+                                    break;
+                                case "xllcorner":
+                                case "xllcenter":
+                                    this.xllcorner = Double.parseDouble(words[1]);
+                                    break;
+                                case "yllcorner":
+                                case "yllcenter":
+                                    this.yllcorner = Double.parseDouble(words[1]);
+                                    break;
+                                case "ulxmax":
+                                    this.ulxmax = Double.parseDouble(words[1]);
+                                    break;
+                                case "ulymax":
+                                    this.ulymax = Double.parseDouble(words[1]);
+                                    break;
+                                case "xdim":
+                                    this.xdim = Double.parseDouble(words[1]);
+                                    break;
+                                case "ydim":
+                                    this.ydim = Double.parseDouble(words[1]);
+                                    break;
+                                case "bandrowbytes":
+                                    this.bandrowbytes = Integer.parseInt(words[1]);
+                                    break;
+                                case "totalrowbytes":
+                                    this.totalrowbytes = Integer.parseInt(words[1]);
+                                    break;
+                                case "bandgapbytes":
+                                    this.bandgapbytes = Integer.parseInt(words[1]);
+                                    break;
+                            }
+                        } catch (NumberFormatException e) {
+                            logger.warn("Can't parse keyword '" + words[0]
+                                    + "' (value='" + words[1]
+                                    + "', lineno=+" + lineno
+                                    + ", file=" + f.getAbsoluteFile()
+                                    + ").", e);
+                        }
+                        lineno++;
+                    }
+                    this.fixValues();
+                }
+
+            } catch (IOException e) {
+                logger.warn("Couldn't read " + FILE_EXTENSION + " file (" + f.getAbsoluteFile() + ")", e);
+                throw e;
+            } catch (Exception e) {
+                String msg = "Couldn't read " + FILE_EXTENSION + " file (" + f.getAbsoluteFile() + ")";
+                logger.warn(msg, e);
+                throw new IOException(msg, e);
+            }
+        }
+    }
+
+    private void fixValues() {
+        @SuppressWarnings("LocalVariableHidesMemberVariable")
+        boolean valid = true;
+
+        if (this.pixeltype != null) {
+            switch (this.pixeltype) {
+                case "signedint":
+                    this.nbits = 32;
+                    break;
+                case "byte_unsigned":
+                    this.nbits = 8;
+                    break;
+            }
+        }
+
+        switch (this.getNbits()) {
+            case 1:
+            case 4:
+                logger.warn("nbits keyword has a non supported value of " + this.getNbits() + " (" + this.source.getAbsolutePath() + ").");
+                valid = false;
+                break;
+            case 8:
+            case 16:
+            case 32:
+            case 64:
+                break;
+            default:
+                logger.warn("nbits keyword has an invalid value of " + this.getNbits() + " (" + this.source.getAbsolutePath() + ").");
+                this.nbits = 1;
+                valid = false;
+                break;
+        }
+
+        switch (this.getLayout()) {
+            case LAYOUT_BIL:
+            case LAYOUT_BIP:
+            case LAYOUT_BSQ:
+                break;
+            default:
+                logger.warn("layout keyword has an invalid value of '" + this.getLayout() + "' (" + this.source.getAbsolutePath() + ").");
+                this.layout = LAYOUT_BIL;
+                valid = false;
+                break;
+        }
+
+        if( StringUtils.isEmpty(this.byteorder_word) ) {
+            this.byteorder = ByteOrder.nativeOrder();
+            if( this.byteorder == ByteOrder.BIG_ENDIAN ) {
+                this.byteorder_word = "msbfirst";
+            } else {
+                this.byteorder_word = "lsbfirst";
+            }
+        } else {
+            switch(this.byteorder_word) {
+                case "lsbfirst":
+                case "little_endian":
+                case "littleendian":
+                case "intel":
+                case "i":
+                    this.byteorder = ByteOrder.LITTLE_ENDIAN;
+                    break;
+                case "motorola":
+                case "m":
+                case "msbfirst":
+                case "big_endian":
+                case "bigendian":
+                    this.byteorder = ByteOrder.BIG_ENDIAN;
+                    break;
+                default:
+                    logger.warn("byteorder keyword has an invalid value of '" + this.byteorder_word + "' (" + this.source.getAbsolutePath() + ").");
+                    this.byteorder = ByteOrder.nativeOrder();
+            }
+        }
+        if (this.getNrows() == NONE || this.getNcols() == NONE) {
+            logger.warn("nrows/ncols keywords has an invalid value of '" + this.getNrows() + "/" + this.getNcols() + "' (" + this.source.getAbsolutePath() + ").");
+            valid = false;
+        }
+        if (this.getUlymax() == NONE) {
+            this.ulymax = this.getNrows() - 1;
+        }
+        if (this.getBandrowbytes() == NONE) {
+            this.bandrowbytes = (this.getNcols() * this.getNbits()) / 8;
+        }
+        switch (this.getLayout()) {
+            case LAYOUT_BIL:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = this.getNbands() * this.getBandrowbytes();
+                }
+                this.bandgapbytes = 0;
+                break;
+            case LAYOUT_BIP:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = (this.getNcols() * this.getNbands() * this.getNbits()) / 8;
+                }
+                this.bandgapbytes = 0;
+                break;
+            case LAYOUT_BSQ:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = 0;
+                }
+                if (this.getBandgapbytes() == NONE) {
+                    this.bandgapbytes = 0;
+                }
+                break;
+        }
+        this.valid = valid;
+    }
+
+    @Override
+    public int getDataType() {
+        if (this.pixeltype != null) {
+            switch (this.pixeltype) {
+                case "signedint":
+                    return BufferManager.TYPE_INT;
+                case "byte_unsigned":
+                    return BufferManager.TYPE_BYTE;
+            }
+        }
+        switch (this.getNbits()) {
+            case 1:
+            case 4:
+            default:
+                return BufferManager.TYPE_UNDEFINED;
+            case 8:
+                return BufferManager.TYPE_BYTE;
+            case 16:
+                return BufferManager.TYPE_USHORT;
+            case 32:
+                return BufferManager.TYPE_INT;
+            case 64:
+                return BufferManager.TYPE_DOUBLE;
+        }
+    }
+
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        StringBuilder builder = new StringBuilder();
+        builder.append("; ").append(this.comments).append("\n");
+        builder.append("nrows ").append(this.nrows).append("\n");
+        builder.append("ncols ").append(this.ncols).append("\n");
+        builder.append("nbands ").append(this.nbands).append("\n");
+        builder.append("nbits ").append(this.nbits).append("\n");
+        builder.append("layout ").append(LAYOUT_BSQ).append("\n");
+        builder.append("byteorder ").append(this.byteorder_word).append("\n");
+        builder.append("ulxmax ").append(this.ulxmax).append("\n");
+        builder.append("ulymax ").append(this.ulymax).append("\n");
+        builder.append("ydim ").append(this.ydim).append("\n");
+        builder.append("xdim ").append(this.xdim).append("\n");
+        
+        FileUtils.write(file, builder.toString());
+    }
+    
+    @Override
+    public void setByteOrder(ByteOrder order) {
+        this.byteorder = order;
+        if( order == ByteOrder.BIG_ENDIAN ) {
+            this.byteorder_word = "msbfirst";
+        } else {
+            this.byteorder_word = "lsbfirst";
+        }
+    }
+    
+    @Override
+    public void setNBands(int nbands) {
+        this.nbands = nbands;
+    }
+    
+    @Override
+    public void setDataType(int dataType) {
+        switch(dataType) {
+            case BufferManager.TYPE_BYTE:
+                this.nbits = 8;
+                break;
+            case BufferManager.TYPE_USHORT:
+                this.nbits = 16;
+                break;
+            case BufferManager.TYPE_INT:
+                this.nbits = 32;
+                break;
+            case BufferManager.TYPE_DOUBLE:
+                this.nbits = 64;
+                break;
+            default:
+                throw new IllegalArgumentException("The data type "+dataType +" is not supported");
+        }
+        
+    }
+    
+    @Override
+    public void setDimensions(int nrows, int ncols, Envelope envelope) {
+        this.ncols = ncols;
+        this.nrows = nrows;
+
+        Point min = envelope.getLowerCorner();
+        Point max = envelope.getUpperCorner();
+        
+        this.ulxmax = min.getX();
+        this.ulymax = max.getY();
+        this.ydim = (min.getY() - max.getY()) / this.nrows;
+        this.xdim = (max.getX() - min.getX()) / this.ncols;
+    }
+    
+    @Override
+    public Envelope getEnvelope() {
+        Envelope envelope = null;
+        try {
+            if (!Double.isNaN(this.xllcorner)
+                    && !Double.isNaN(this.yllcorner)
+                    && this.cellsize > 0) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        this.xllcorner,
+                        this.yllcorner,
+                        this.xllcorner + (this.ncols * this.cellsize),
+                        this.yllcorner + (this.nrows * this.cellsize),
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && !Double.isNaN(this.ulxmax)
+                    && !Double.isNaN(this.ulymax)
+                    && !Double.isNaN(this.xdim)
+                    && !Double.isNaN(this.ydim)) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        this.ulxmax,
+                        this.ulymax - (this.nrows * this.ydim),
+                        this.ulxmax + (this.ncols * this.xdim),
+                        this.ulymax,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && !Double.isNaN(this.xdim)
+                    && !Double.isNaN(this.ydim)) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols * this.xdim,
+                        this.nrows * this.ydim,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && this.cellsize > 0) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols * this.cellsize,
+                        this.nrows * this.cellsize,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols,
+                        this.nrows,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+        } catch (Exception ex) {
+            logger.debug("Can't calculate envelope.", ex);
+        }
+        return envelope;
+    }
+
+    /**
+     * @return the nrows
+     */
+    @Override
+    public int getNrows() {
+        return nrows;
+    }
+
+    /**
+     * @return the ncols
+     */
+    @Override
+    public int getNcols() {
+        return ncols;
+    }
+
+    /**
+     * @return the nbands
+     */
+    @Override
+    public int getNbands() {
+        return nbands;
+    }
+
+    /**
+     * @return the nbits
+     */
+    @Override
+    public int getNbits() {
+        return nbits;
+    }
+
+    /**
+     * @return the byteorder
+     */
+    @Override
+    public ByteOrder getByteorder() {
+        return byteorder;
+    }
+
+    /**
+     * @return the layout
+     */
+    @Override
+    public String getLayout() {
+        return layout;
+    }
+
+    /**
+     * @return the skipbytes
+     */
+    @Override
+    public int getSkipbytes() {
+        return skipbytes;
+    }
+
+    /**
+     * @return the ulxmax
+     */
+    @Override
+    public double getUlxmax() {
+        return ulxmax;
+    }
+
+    /**
+     * @return the ulymax
+     */
+    @Override
+    public double getUlymax() {
+        return ulymax;
+    }
+
+    /**
+     * @return the xdim
+     */
+    @Override
+    public double getXdim() {
+        return xdim;
+    }
+
+    /**
+     * @return the ydim
+     */
+    @Override
+    public double getYdim() {
+        return ydim;
+    }
+
+    /**
+     * @return the bandrowbytes
+     */
+    @Override
+    public int getBandrowbytes() {
+        return bandrowbytes;
+    }
+
+    /**
+     * @return the totalrowbytes
+     */
+    @Override
+    public int getTotalrowbytes() {
+        return totalrowbytes;
+    }
+
+    /**
+     * @return the bandgapbytes
+     */
+    @Override
+    public int getBandgapbytes() {
+        return bandgapbytes;
+    }
+
+    /**
+     * @return the isValid
+     */
+    @Override
+    public boolean isValid() {
+        return valid;
+    }
+
+    /**
+     * @return the comments
+     */
+    @Override
+    public String getComments() {
+        return comments;
+    }
+
+    /**
+     * @param comments the comments to set
+     */
+    @Override
+    public void setComments(String comments) {
+        this.comments = comments;
+    }
+
+    /**
+     * @return the nodata_value
+     */
+    @Override
+    public double getNodata_value() {
+        return nodata_value;
+    }
+
+    /**
+     * @return the xllcorner
+     */
+    @Override
+    public double getXllcorner() {
+        return xllcorner;
+    }
+
+    /**
+     * @return the yllcorner
+     */
+    @Override
+    public double getYllcorner() {
+        return yllcorner;
+    }
+
+    /**
+     * @return the cellsize
+     */
+    @Override
+    public int getCellsize() {
+        return cellsize;
+    }
+
+    @Override
+    public int getBandSize() {
+        return (this.nrows * this.ncols * this.nbits) + this.bandgapbytes;
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultSTXFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultSTXFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/impl/DefaultSTXFile.java	(revision 43876)
@@ -0,0 +1,250 @@
+
+package org.gvsig.basicformats.impl;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.basicformats.STXFile;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class DefaultSTXFile implements STXFile {
+
+    private static final Logger logger = LoggerFactory.getLogger(DefaultSTXFile.class);
+
+
+    private File source;
+    private List<STXBand> bands;
+
+    public static class DefaultSTXBand implements STXBand {
+
+        private int band;
+        private double minimum;
+        private double maximum;
+        private double mean; // Optional
+        private double std_deviation; // Optional
+        private double linear_stretch_min; // Optional
+        private double linear_stretch_max; // Optional
+
+        private boolean valid = false;
+
+        public DefaultSTXBand() {
+
+        }
+
+        public DefaultSTXBand(
+            int band,
+            double minimum,
+            double maximum,
+            double mean,
+            double std_deviation,
+            double linear_stretch_min,
+            double linear_stretch_max
+            ) {
+            this();
+            this.band = band;
+            this.minimum = minimum;
+            this.maximum = maximum;
+            this.mean = mean;
+            this.std_deviation = std_deviation;
+            this.linear_stretch_min = linear_stretch_min;
+            this.linear_stretch_max = linear_stretch_max;
+        }
+
+        @SuppressWarnings("OverridableMethodCallInConstructor")
+        public DefaultSTXBand(String line) {
+            this();
+            this.parse(line);
+        }
+
+        @Override
+        public void parse(String line) {
+            valid = false;
+            String[] words = StringUtils.split(line.trim().toLowerCase());
+            if( words.length < 7 ) {
+                throw new IllegalArgumentException("At least 7 parameters are needed ("+line+").");
+            }
+            this.band = Integer.parseInt(words[0]);
+            this.minimum = Double.parseDouble(words[1]);
+            this.maximum = Double.parseDouble(words[2]);
+            if( "#".equals(words[3]) ) {
+                this.mean = Double.NaN;
+            } else {
+                this.mean = Double.parseDouble(words[3]);
+            }
+            if( "#".equals(words[4]) ) {
+                this.std_deviation = Double.NaN;
+            } else {
+                this.std_deviation = Double.parseDouble(words[4]);
+            }
+            if( "#".equals(words[5]) ) {
+                this.linear_stretch_min = Double.NaN;
+            } else {
+                this.linear_stretch_min = Double.parseDouble(words[5]);
+            }
+            if( "#".equals(words[6]) ) {
+                this.linear_stretch_max = Double.NaN;
+            } else {
+                this.linear_stretch_max = Double.parseDouble(words[6]);
+            }
+            valid = true;
+        }
+
+        @Override
+        public String toString() {
+            StringBuilder builder = new StringBuilder();
+            builder.append(this.band).append(" ");
+            builder.append(this.minimum).append(" ");
+            builder.append(this.maximum).append(" ");
+            if( Double.isNaN(this.mean) ) {
+                builder.append("# ");
+            } else {
+                builder.append(this.mean).append(" ");
+            }
+            if( Double.isNaN(this.std_deviation) ) {
+                builder.append("# ");
+            } else {
+                builder.append(this.std_deviation).append(" ");
+            }
+            if( Double.isNaN(this.linear_stretch_min) ) {
+                builder.append("# ");
+            } else {
+                builder.append(this.linear_stretch_min).append(" ");
+            }
+            if( Double.isNaN(this.linear_stretch_max) ) {
+                builder.append("# ");
+            } else {
+                builder.append(this.linear_stretch_max).append(" ");
+            }
+            return builder.toString();
+        }
+
+        @Override
+        public int getBand() {
+            return band;
+        }
+
+        @Override
+        public double getMinimum() {
+            return minimum;
+        }
+
+        @Override
+        public double getMaximum() {
+            return maximum;
+        }
+
+        @Override
+        public double getMean() {
+            return mean;
+        }
+
+        @Override
+        public double getStdDeviation() {
+            return std_deviation;
+        }
+
+        @Override
+        public double getLinearStretchMin() {
+            return linear_stretch_min;
+        }
+
+        @Override
+        public double getLinearStretchMax() {
+            return linear_stretch_max;
+        }
+
+        @Override
+        public boolean isValid() {
+            return valid;
+        }
+    }
+
+   public DefaultSTXFile() {
+        this.source = null;
+        this.bands = new ArrayList<>();
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath())+"."+FILE_EXTENSION);
+        return f;
+    }
+
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public void read(File file) throws IOException {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                this.bands = new ArrayList<>();
+                List<String> lines = FileUtils.readLines(f);
+                if (lines != null) {
+                    this.source = f.getAbsoluteFile();
+                    int lineno = 1;
+                    for (String line : lines) {
+                        try {
+                            DefaultSTXBand band = new DefaultSTXBand(line.trim());
+                            this.bands.add(band);
+                        } catch(IllegalArgumentException e) {
+                            logger.warn("Can't parse line '" + line
+                                    + "' (lineno=+" + lineno
+                                    + ", file=" + f.getAbsoluteFile()
+                                    + ").", e);
+
+                        }
+                    }
+                }
+                this.bands = Collections.unmodifiableList(this.bands);
+            } catch (IOException e) {
+                logger.warn("Couldn't read "+FILE_EXTENSION+" file (" + f.getAbsoluteFile() + ")", e);
+                throw e;
+            }
+        }
+    }
+
+    @Override
+    public List<STXBand> getBands() {
+        return this.bands;
+    }
+
+    @Override
+    public void clear() {
+        this.bands = new ArrayList<>();
+    }
+
+    @Override
+    public void addBand(
+            int band,
+            double minimum,
+            double maximum,
+            double mean,
+            double std_deviation,
+            double linear_stretch_min,
+            double linear_stretch_max
+        ) {
+        DefaultSTXBand b = new DefaultSTXBand(band, minimum, maximum, mean, std_deviation, linear_stretch_min, linear_stretch_max);
+        this.bands.add(b);
+    }
+
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        List<String> lines = new ArrayList<>();
+        for (STXBand band : this.bands) {
+            lines.add(band.toString());
+        }
+        FileUtils.writeLines(f, lines);
+        this.source = f;
+    }
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/WLDFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/WLDFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/WLDFile.java	(revision 43876)
@@ -0,0 +1,45 @@
+
+package org.gvsig.basicformats;
+
+import org.gvsig.fmap.geom.primitive.Envelope;
+
+
+public interface WLDFile extends FormatFile {
+
+    String FILE_EXTENSION = "wld";
+
+    Envelope getEnvelope(int rows, int columns);
+
+    void setValue(Envelope envelope, int rows, int columns);
+
+    /**
+     * @return the pixelSizeX
+     */
+    double getPixelSizeX();
+
+    /**
+     * @return the pixelSizeY
+     */
+    double getPixelSizeY();
+
+    /**
+     * @return the rotationAxisX
+     */
+    double getRotationAxisX();
+
+    /**
+     * @return the rotationAxisY
+     */
+    double getRotationAxisY();
+
+    /**
+     * @return the upperLeftPixelCenterCoordX
+     */
+    double getUpperLeftPixelCenterCoordX();
+
+    /**
+     * @return the upperLeftPixelCenterCoordY
+     */
+    double getUpperLeftPixelCenterCoordY();
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/FormatFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/FormatFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.basicformats/src/main/java/org/gvsig/basicformats/FormatFile.java	(revision 43876)
@@ -0,0 +1,17 @@
+
+package org.gvsig.basicformats;
+
+import java.io.File;
+import java.io.IOException;
+
+
+public interface FormatFile {
+ 
+    public File getFile(File file);
+
+    public File getFile();
+
+    public void read(File file) throws IOException ;
+
+    public void write(File file) throws IOException ;       
+}
